package cd.casic.ci.common.pipeline;

import cd.casic.ci.common.pipeline.type.DispatchType;
import com.fasterxml.jackson.databind.jsontype.NamedType;
import com.fasterxml.jackson.databind.module.SimpleModule;
import lombok.extern.slf4j.Slf4j;

import java.util.Map;
import java.util.ServiceLoader;

/**
 * @Author：mianbin
 * @Package：cd.casic.ci.common.pipeline
 * @Project：ops-pro
 * @name：DispatchSubTypeRegisterLoader
 * @Date：2025/03/25 17:37
 * @Filename：DispatchSubTypeRegisterLoader
 * @description：Todo
 */
@Slf4j
public class DispatchSubTypeRegisterLoader {

    public static void registerType() {
        Class<DispatchSubTypeFetcher> clazz = DispatchSubTypeFetcher.class;
        ServiceLoader<DispatchSubTypeFetcher> fetcheries = ServiceLoader.load(clazz);

        if (!fetcheries.iterator().hasNext()) {
            fetcheries = ServiceLoader.load(clazz, ServiceLoader.class.getClassLoader());
        }
        SimpleModule typeSubModule = new SimpleModule();
        for (DispatchSubTypeFetcher fetcher : fetcheries) {
            log.info("[DISPATCH_FETCHER]| {}", fetcher.getClass());
            Map<String, Class<? extends DispatchType>> jsonSubTypes = fetcher.jsonSubTypes();
            for (Map.Entry<String, Class<? extends DispatchType>> entry : jsonSubTypes.entrySet()) {
                typeSubModule.registerSubtypes(new NamedType(entry.getValue(), entry.getKey()));
                log.info("[REGISTER_DISPATCH]|{} for {}", entry.getValue(), entry.getKey());
            }
        }
    }
}
