package cd.casic.ci.common.pipeline;

import cd.casic.ci.common.pipeline.enums.PipelineStorageType;
import cd.casic.ci.common.pipeline.pojo.PipelineModelAndSetting;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

/**
 * @Author：mianbin
 * @Package：cd.casic.ci.common.pipeline
 * @Project：ops-pro
 * @name：PipelineVersionWithModelRequest
 * @Date：2025/03/25 17:41
 * @Filename：PipelineVersionWithModelRequest
 * @description：Todo
 */
@Data
@Schema(title = "流水线版本与模型请求")
public class PipelineVersionWithModelRequest {

    @Schema(title = "流水线ID（为空时导入并创建流水线）", required = false)
    private String pipelineId;

    @Schema(title = "草稿的来源版本（前端保存时传递）", required = true)
    private int baseVersion;

    @Schema(title = "流水线模型", required = true)
    private PipelineModelAndSetting modelAndSetting;

    @Schema(title = "流水线YAML编排（不为空时以YAML为准）", required = false)
    private String yaml;

    @Schema(title = "存储格式", required = false)
    private PipelineStorageType storageType = PipelineStorageType.MODEL;

    @Schema(title = "版本变更说明", required = false)
    private String description;
}
