package cd.casic.ci.common.pipeline.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * @Author：mianbin
 * @Package：cd.casic.ci.common.pipeline.enums
 * @Project：ops-pro
 * @name：VersionStatus
 * @Date：2025/03/25 17:24
 * @Filename：VersionStatus
 * @description：Todo
 */
@Getter
@AllArgsConstructor
public enum VersionStatus {
    RELEASED("已发布版本"),
    COMMITTING("草稿版本"),
    BRANCH("分支版本"),
    BRANCH_RELEASE("通过分支版本发布（中间态）"),
    DRAFT_RELEASE("通过草稿版本发布（中间态）"),
    DELETE("被删除（无法查询）");

    private final String statusName;

    public VersionStatus fix() {
        return this == BRANCH_RELEASE ? BRANCH : this == DRAFT_RELEASE ? RELEASED : this;
    }

    public boolean isReleasing() {
        return this == RELEASED || this == BRANCH_RELEASE || this == DRAFT_RELEASE;
    }

    public boolean isNotReleased() {
        return this == COMMITTING || this == BRANCH;
    }
}
