package cd.casic.pipeline.dispatch.api;

import cd.casic.framework.commons.pojo.CommonResult;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.web.bind.annotation.*;

import static cd.casic.ci.common.pipeline.constant.OpsHeader.*;

@Tag(name = "BUILD_JOBS_PROJECT_QUOTA", description = "Job配额管理")
@RestController
@RequestMapping("/build/quotas/running")
public interface BuildJobQuotaBusinessResource {

    @Operation(summary = "上报一个Agent启动")
    @PostMapping("/agent/start")
    CommonResult<Boolean> addRunningAgent(
            @Parameter(description = "项目ID", required = true)
            @RequestHeader(AUTH_HEADER_DEVOPS_PROJECT_ID) String projectId,
            @Parameter(description = "流水线ID", required = true)
            @RequestHeader(AUTH_HEADER_DEVOPS_PIPELINE_ID) String pipelineId,
            @Parameter(description = "构建ID", required = true)
            @RequestHeader(AUTH_HEADER_DEVOPS_BUILD_ID) String buildId,
            @Parameter(description = "构建job序号", required = true)
            @RequestHeader(AUTH_HEADER_DEVOPS_VM_SEQ_ID) String vmSeqId,
            @Parameter(description = "executeCount", required = true)
            @RequestParam("executeCount") Integer executeCount
    );

    @Operation(summary = "上报一个Agent结束")
    @DeleteMapping("/agent/shutdown")
    CommonResult<Boolean> removeRunningAgent(
            @Parameter(description = "项目ID", required = true)
            @RequestHeader(AUTH_HEADER_DEVOPS_PROJECT_ID) String projectId,
            @Parameter(description = "流水线ID", required = true)
            @RequestHeader(AUTH_HEADER_DEVOPS_PIPELINE_ID)
            String pipelineId,
            @Parameter(description = "构建ID", required = true)
            @RequestHeader(AUTH_HEADER_DEVOPS_BUILD_ID)
            String buildId,
            @Parameter(description = "构建job序号", required = true)
            @RequestHeader(AUTH_HEADER_DEVOPS_VM_SEQ_ID)
            String vmSeqId,
            @Parameter(description = "executeCount", required = true)
            @RequestParam("executeCount")
            Integer executeCount
    );
}