package cd.casic.pipeline.dispatch.pojo;

import cd.casic.ci.common.pipeline.enums.ChannelCode;
import cd.casic.pipeline.dispatch.pojo.enums.JobQuotaVmType;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author by mianbin
 * @Classname JobQuotaSystem
 * @Description TODO
 * @Date 2025/4/8 16:38
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@Schema(title = "系统默认JOB配额")
public class JobQuotaSystem {
    @Schema(title = "构建机类型", required = true)
    private JobQuotaVmType vmType;
    @Schema(title = "构建来源，默认BS", required = true)
    private String channelCode = ChannelCode.BS.name();
    @Schema(title = "蓝盾系统最大并发JOB数，默认5000", required = false)
    private int runningJobMaxSystem;
    @Schema(title = "单项目默认最大并发JOB数， 默认500", required = false)
    private int runningJobMaxProject;
    @Schema(title = "系统默认所有单个JOB最大执行时间，默认24小时", required = false)
    private int runningTimeJobMax;
    @Schema(title = "默认单项目所有JOB最大执行时间，默认5000小时/月", required = false)
    private int runningTimeJobMaxProject;
    @Schema(title = "项目执行job数量告警阈值，百分比，默认80", required = false)
    private int projectRunningJobThreshold;
    @Schema(title = "项目执行job时间告警阈值，百分比，默认80", required = false)
    private int projectRunningTimeThreshold;
    @Schema(title = "系统执行job数量告警阈值，百分比，默认80", required = false)
    private int systemRunningJobThreshold;
    @Schema(title = "创建时间", required = false)
    private String createdTime;
    @Schema(title = "修改时间", required = false)
    private String updatedTime;
    @Schema(title = "操作人", required = false)
    private String operator;
}