package cd.casic.pipeline.dispatch.pojo.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * @author by mianbin
 * @Classname PipelineTaskStatus
 * @Description TODO
 * @Date 2025/4/8 16:15
 */
@Getter
@AllArgsConstructor
public enum PipelineTaskStatus {
    QUEUE(1),
    RUNNING(2),
    DONE(3),
    FAILURE(4);

    private final int status;

    public static PipelineTaskStatus toStatus(int status) {
        for (PipelineTaskStatus taskStatus : values()) {
            if (taskStatus.getStatus() == status) {
                return taskStatus;
            }
        }
        throw new RuntimeException("Can't find the pipeline task status(" + status + ")");
    }

    public static PipelineTaskStatus parse(String input) {
        for (PipelineTaskStatus taskStatus : values()) {
            if (taskStatus.name().equals(input)) {
                return taskStatus;
            }
        }
        return DONE;
    }
}
