package cd.casic.pipeline.dispatch.pojo.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.ToString;

/**
 * @author by mianbin
 * @Classname TaskPhase
 * @Description TODO
 * @Date 2025/4/8 16:16
 */
@Getter
@ToString
@AllArgsConstructor
public enum TaskPhase {
    READY((byte) 0),
    QUEUE((byte) 1),
    RUNNING((byte) 3),
    SUCCESS((byte) 101),
    FAIL((byte) 102),
    ABORT((byte) 104),
    QUEUE_TIMEOUT((byte) 105), // 排队超时
    TASK_TIMEOUT((byte) 106); // 构建超时

    private final byte value;

    public static TaskPhase fromShort(byte value) {
        for (TaskPhase taskPhase : values()) {
            if (taskPhase.getValue() == value) {
                return taskPhase;
            }
        }
        return null;
    }

    public static boolean isFinish(byte value) {
        return value >= SUCCESS.getValue();
    }
}
