package cd.casic.ci.event.enums;

import lombok.Getter;

/**
 * @Author：mianbin
 * @Package：cd.casic.ci.event.enums
 * @Project：ops-pro
 * @name：ActionType
 * @Date：2025/03/25 9:51
 * @Filename：ActionType
 * @description：Todo
 */
@Getter
public enum ActionType {
    RETRY, // 重试
    START, // 开始
    REFRESH, // 刷新ElementAdditionalOptions
    END, // 强制结束当前节点，会导致当前构建容器结束
    SKIP, // 跳过-不执行
    TERMINATE, // 终止
    ARCHIVE; // 归档

    public boolean isStartOrRefresh() {
        return isStart() || this == REFRESH;
    }

    public boolean isStart() {
        return START == this || RETRY == this;
    }

    public boolean isEnd() {
        return END == this || isTerminate();
    }

    public boolean isTerminate() {
        return TERMINATE == this;
    }

    public boolean isRetry() {
        return RETRY == this;
    }

    /**
     * @deprecated replace by isStart
     */
    @Deprecated
    public static boolean isStart(ActionType actionType) {
        return actionType.isStart();
    }

    /**
     * @deprecated replace by isEnd
     */
    @Deprecated
    public static boolean isEnd(ActionType actionType) {
        return actionType.isEnd();
    }

    /**
     * @deprecated replace by isTerminate
     */
    @Deprecated
    public static boolean isTerminate(ActionType actionType) {
        return actionType.isTerminate();
    }
}
