package cd.casic.ci.process.api.engine.pojo;

import cd.casic.ci.common.pipeline.enums.ChannelCode;
import cd.casic.ci.common.pipeline.enums.VersionStatus;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author by mianbin
 * @Classname PipelineVersionWithInfo
 * @Description TODO
 * @Date 2025/3/31 17:02
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@Schema(title = "流水线信息")
public class PipelineVersionWithInfo {
    @Schema(title = "项目ID")
    private String projectId;

    @Schema(title = "流水线DI")
    private String pipelineId;

    @Schema(title = "模板ID")
    private String templateId;

    @Schema(title = "流水线名称")
    private String pipelineName;

    @Schema(title = "流水线描述")
    private String pipelineDesc;

    @Schema(title = "版本")
    private int version = 1;

    @Schema(title = "创建时间")
    private long createTime;

    @Schema(title = "更新时间")
    private Long updateTime;

    @Schema(title = "版本创建者")
    private String creator;

    @Schema(title = "上一次的更新者")
    private String lastModifyUser;

    @Schema(title = "渠道号")
    private ChannelCode channelCode;

    @Schema(title = "是否能够手动启动")
    private boolean canManualStartup;

    @Schema(title = "是否可以跳过")
    private boolean canElementSkip;

    @Schema(title = "任务数")
    private int taskCount;

    @Schema(title = "版本名称")
    private String versionName = "";

    @Schema(title = "ID")
    private Long id;

    @Schema(title = "流水线组名称列表", required = false)
    private java.util.List<String> viewNames;

    @Schema(title = "关联构建记录总数", required = false)
    private Integer referCount;

    @Schema(title = "发布版本号", required = false)
    private Integer versionNum;

    @Schema(title = "编排版本号", required = false)
    private Integer pipelineVersion;

    @Schema(title = "触发器版本号", required = false)
    private Integer triggerVersion;

    @Schema(title = "配置版本号", required = false)
    private Integer settingVersion;

    @Schema(title = "草稿版本状态标识", required = false)
    private VersionStatus status = VersionStatus.RELEASED;

    @Schema(title = "版本变更说明", required = false)
    private String description;

    @Schema(title = "该版本的来源版本（空时一定为主路径）", required = false)
    private Integer baseVersion;

    @Schema(title = "草稿的来源版本名称（只在草稿版本有值）", required = false)
    private String baseVersionName;

    @Schema(title = "调试构建ID", required = false)
    private String debugBuildId;
}
