package cd.casic.ci.dal.v2;

import cd.casic.ci.constants.QualityConstants;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.HashMap;
import java.util.Map;

/**
 * @author by mianbin
 * @Classname ControlPointPosition
 * @Date 2025/3/20 19:59
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class ControlPointPosition {
    private String name;
    private String code;

    public static final String BEFORE_POSITION = "BEFORE";
    public static final String AFTER_POSITION = "AFTER";

    private static Map<String, String> POSITION_NAME_MAP = new HashMap<>();

    static {
        POSITION_NAME_MAP.put(BEFORE_POSITION, QualityConstants.BK_BEFORE_POSITION);
        POSITION_NAME_MAP.put(AFTER_POSITION, QualityConstants.BK_AFTER_POSITION);
    }

    public static ControlPointPosition create(String code) {
        String name = POSITION_NAME_MAP.get(code);
        return new ControlPointPosition(code, name);
    }
}
