package cd.casic.pipeline.store.pojo.atom;

import cd.casic.pipeline.store.pojo.atom.enums.AtomTypeEnum;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.util.List;

@Data
@Schema(title = "审核插件请求报文")
public class ApproveReq {
    @Schema(title = "插件标识")
    private String atomCode;
    @Schema(title = "审核结果：PASS：通过|REJECT：驳回")
    private String result;
    @Schema(title = "审核结果说明")
    private String message;
    @Schema(title = "权重（数值越大代表权重越高）")
    private Integer weight;
    @Schema(title = "插件类型，SELF_DEVELOPED：自研 THIRD_PARTY：第三方开发", required = true)
    private AtomTypeEnum atomType;
    @Schema(title = "是否为默认插件（默认插件默认所有项目可见）true：默认插件 false：普通插件", required = true)
    private Boolean defaultFlag;
    @Schema(title = "服务范围", required = true)
    private List<String> serviceScope;
    @Schema(title = "无构建环境插件是否可以在有构建环境运行标识", required = false)
    private Boolean buildLessRunFlag;
}