package cd.casic.pipeline.store.pojo.common;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.util.List;

@Data
@Schema(title = "更新研发商店流水线模型请求报文")
public class UpdateStorePipelineModelRequest {
    @Schema(title = "适用范围(ALL:全部|GRAY:灰度|NO_GRAY:非灰度|SPEC:特别指定)", required = true)
    private String scopeType;
    
    @Schema(title = "组件类型", required = true)
    private String storeType;
    
    @Schema(title = "组件代码集合(scopeType为SPEC才需要传)", required = false)
    private List<String> storeCodeList;
    
    @Schema(title = "流水线模型", required = false)
    private String pipelineModel;
}