package cd.casic.pipeline.store.pojo.common.publication;

import cd.casic.pipeline.store.pojo.common.enums.ReleaseTypeEnum;
import cd.casic.pipeline.store.pojo.common.enums.StoreTypeEnum;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.util.List;

@Data
@Schema(title = "组件包相关信息修改请求报文体")
public class StorePkgInfoUpdateRequest {

    @Schema(title = "组件类型", required = true)
    private StoreTypeEnum storeType;

    @Schema(title = "组件代码", required = true)
    private String storeCode;

    @Schema(title = "组件版本号", required = true)
    private String version;

    @Schema(title = "组件包环境信息", required = true)
    private List<StorePkgEnvInfo> storePkgEnvInfos;

    @Schema(title = "发布类型", required = false)
    private ReleaseTypeEnum releaseType;
}
